;-------------------------------------------------------------------------------
;---- DISASSEMBLE INFORMATION :
;---- File Name: Ava_T1_Refresh_Mouse_v1.02.03[Post_MP_FW]_20220627.hex
;---- CPU Family:NRF52
;---- CPU Factory:NORDIC
;---- CPU Model: NRF52840
;---- Time Stamp: 621073228816300
;----
;----   Writen by: beacon_light@163.com
;----      Wechat: 18676693732
;----          QQ: 19263826
;-------------------------------------------------------------------------------
; Amount of memory (in bytes) allocated for Stack
; Tailor this value to your application needs
; <h> Stack Configuration
;   <o> Stack Size (in Bytes) <0x0-0xFFFFFFFF:8>
; </h>
Stack_Size      EQU     0x00000400

                AREA    STACK, NOINIT, READWRITE, ALIGN=3
Stack_Mem       SPACE   Stack_Size
__initial_sp
                PRESERVE8
                THUMB

                AREA    RESET, DATA, READONLY
                DCD __initial_sp
__Vectors       DCD Reset_Handler
                
				;ALIGN 0X200
; Segment type: Pure code

                AREA    |.text|, CODE, READONLY
				;AREA    RAMCODE, CODE, READONLY

; =============== S U B R O U T I N E =======================================

; void BKPT(int r0, char* r1, int len, int r3)
; { 
;    int c, temp;
;    for(; len; len--,r1++) {
;       temp = *r1<<24;
;       r0 ^= temp;
;       for(c=8; c; c--) { 
;           temp = r0; 
;           r0 <<= 1; 
;           if(temp&0x80000000) { 
;               r0 ^= r3; 
;           }
;       }
;    }
; }
Reset_Handler
;BKPT_20000000
                BKPT    0
                B       loc_2000001A

loc_20000004
                LDRB    R5, [R1]
                LSLS    R5, R5, #0x18
                EORS    R0, R5
                MOVS    R4, #8

loc_2000000C
                LSLS    R0, R0, #1
                BCC     loc_20000012
                EORS    R0, R3

loc_20000012
                SUBS    R4, R4, #1
                BNE     loc_2000000C
                ADDS    R1, R1, #1
                SUBS    R2, R2, #1

loc_2000001A
                CMP     R2, #0
                BNE     loc_20000004
                BX      LR
; End of function BKPT_20000000


; =============== S U B R O U T I N E =======================================
; int Init()
; { 
;     // https://blog.csdn.net/qq_43666306/article/details/109311798
;     // 1, FPEC键寄存器 (FLASH_KEYR)
;     // 其中FPEC总共有3个键值：
;     // RDPRT键 = 0X000000A5 用于解除读保护
;     // KEY1 = 0X45670123 用于解除闪存锁
;     // KEY2 = 0XCDEF89AB 用于解除闪存锁
;     
;     FLASH->ACR = 0; // 0x40022000
;     FLASH->KEYR = FLASH_KEY1; // 0x45670123, unlock Flash Lock 
;     FLASH->KEYR = FLASH_KEY2; // 0xCDEF89AB, unlock Flash Lock 
;     if(FLASH->OBR&4) {        // User Option: IWDG_SW(Bit0) is Set
;         IWDG->KR = 0x5555; 
;         IWDG->PR = 6; 
;         IWDG->RLR = 0xFFF; 
;     }
;     return 0; 
; }

Init_20000020
                PUSH    {R4,LR}
                MOV     R3, R0
                MOVS    R0, #0
                LDR     R4, off_20000138 ; 0x40022000
                STR     R0, [R4]
                LDR     R0, dword_2000013C ; 0x45670123
                STR     R0, [R4,#4]
                LDR     R0, dword_20000140 ; 0xCDEF89AB
                STR     R0, [R4,#4]
                MOV     R0, R4
                LDR     R0, [R0,#0x1C]
                TST.W   R0, #4
                BNE     loc_2000004E
                MOVW    R0, #0x5555
                LDR     R4, off_20000144 ; 0x40003000
                STR     R0, [R4]
                MOVS    R0, #6
                STR     R0, [R4,#4]
                MOVW    R0, #0xFFF
                STR     R0, [R4,#8]

loc_2000004E
                MOVS    R0, #0
                POP     {R4,PC}
; End of function Init_20000020


; =============== S U B R O U T I N E =======================================
; int UnInit() 
; {
;     FLASH->CR |= CR_LOCK_Set; 
;     return 0; 
; } 

UnInit_20000052
                MOV     R1, R0
                LDR     R0, off_20000138 ; 0x40022000
                LDR     R0, [R0,#0x10]
                ORR.W   R0, R0, #0x80
                LDR     R2, off_20000138 ; 0x40022000
                STR     R0, [R2,#0x10]
                MOVS    R0, #0
                BX      LR
; End of function UnInit_20000052


; =============== S U B R O U T I N E =======================================
; int EraseChip()
; {
;     FLASH->CR |= CR_MER_Set;  // 0x04
;     FLASH->CR |= CR_STRT_Set; // 0x40
;     while(FLASH->SR&FLASH_FLAG_BSY) { 
;         IWDG->KR = 0xAAAA; 
;     }
;     FLASH->CR &= CR_MER_Reset; 
;     return 0; 
; }

EraseChip_20000064
                LDR     R0, off_20000138 ; 0x40022000
                LDR     R0, [R0,#0x10]
                ORR.W   R0, R0, #4
                LDR     R1, off_20000138 ; 0x40022000
                STR     R0, [R1,#0x10]
                MOV     R0, R1
                LDR     R0, [R0,#0x10]
                ORR.W   R0, R0, #0x40
                STR     R0, [R1,#0x10]
                B       loc_20000084
; ---------------------------------------------------------------------------

loc_2000007C
                MOVW    R0, #0xAAAA
                LDR     R1, off_20000144 ; 0x40003000
                STR     R0, [R1]

loc_20000084
                LDR     R0, off_20000138 ; 0x40022000
                LDR     R0, [R0,#0xC]
                TST.W   R0, #1
                BNE     loc_2000007C
                LDR     R0, off_20000138 ; 0x40022000
                LDR     R0, [R0,#0x10]
                BIC.W   R0, R0, #4
                LDR     R1, off_20000138 ; 0x40022000
                STR     R0, [R1,#0x10]
                MOVS    R0, #0
                BX      LR
; End of function EraseChip_20000064


; =============== S U B R O U T I N E =======================================
; int EraseSector(int pageNum) 
; {
;     FLASH->CR |= CR_PER_Set; // 0x02 
;     FLASH->AR = pageNum; 
;     FLASH->CR |= CR_STRT_Set; // 0x40
;     while(FLASH->SR&FLASH_FLAG_BSY) { 
;         IWDG->KR = 0xAAAA; 
;     }
;     FLASH->CR &= CR_PER_Reset; 
;     return 0; 
; }

EraseSector_2000009E
                MOV     R1, R0
                LDR     R0, off_20000138 ; 0x40022000
                LDR     R0, [R0,#0x10]
                ORR.W   R0, R0, #2
                LDR     R2, off_20000138 ; 0x40022000
                STR     R0, [R2,#0x10]
                MOV     R0, R2
                STR     R1, [R0,#0x14]
                LDR     R0, [R0,#0x10]
                ORR.W   R0, R0, #0x40
                STR     R0, [R2,#0x10]
                B       loc_200000C2
; ---------------------------------------------------------------------------

loc_200000BA
                MOVW    R0, #0xAAAA
                LDR     R2, off_20000144 ; 0x40003000
                STR     R0, [R2]

loc_200000C2
                LDR     R0, off_20000138 ; 0x40022000
                LDR     R0, [R0,#0xC]
                TST.W   R0, #1
                BNE     loc_200000BA
                LDR     R0, off_20000138 ; 0x40022000
                LDR     R0, [R0,#0x10]
                BIC.W   R0, R0, #2
                LDR     R2, off_20000138 ; 0x40022000
                STR     R0, [R2,#0x10]
                MOVS    R0, #0
                BX      LR
; End of function EraseSector_2000009E


; =============== S U B R O U T I N E =======================================

; int ProgramPage(char* dst, int len, char* src) 
; { 
;     // Align 2 bytes
;     len += 1; 
;     len &= ~1; 
;     
;     for(; len; len-=2) { 
;         FLASH->CR |= CR_PG_Set; // 0x01 
;         *((uint16_t*)dst) = *((uint16_t*)src); 
;         NOP();
;         while(FLASH->SR&FLASH_FLAG_BSY); 
;         FLASH->CR &= CR_PG_Reset;  
;         if(FLASH->SR&(FLASH_FLAG_PGERR|FLASH_FLAG_WRPRTERR)) { 
;             FLASH->SR |= FLASH_FLAG_PGERR|FLASH_FLAG_WRPRTERR; 
;             return 1; 
;         }
;         dst += 2; 
;         src += 2; 
;     }
;     return 0; 
; }

ProgramPage_200000DC
                PUSH    {R4,LR}
                MOV     R3, R0
                ADDS    R0, R1, #1
                BIC.W   R1, R0, #1
                B       loc_2000012E
; ---------------------------------------------------------------------------

loc_200000E8
                LDR     R0, off_20000138 ; 0x40022000
                LDR     R0, [R0,#0x10]
                ORR.W   R0, R0, #1
                LDR     R4, off_20000138 ; 0x40022000
                STR     R0, [R4,#0x10]
                LDRH    R0, [R2]
                STRH    R0, [R3]
                NOP

loc_200000FA
                LDR     R0, off_20000138 ; 0x40022000
                LDR     R0, [R0,#0xC]
                TST.W   R0, #1
                BNE     loc_200000FA
                LDR     R0, off_20000138 ; 0x40022000
                LDR     R0, [R0,#0x10]
                BIC.W   R0, R0, #1
                LDR     R4, off_20000138 ; 0x40022000
                STR     R0, [R4,#0x10]
                MOV     R0, R4
                LDR     R0, [R0,#0xC]
                TST.W   R0, #0x14
                BEQ     loc_20000128
                MOV     R0, R4
                LDR     R0, [R0,#0xC]
                ORR.W   R0, R0, #0x14
                STR     R0, [R4,#0xC]
                MOVS    R0, #1

locret_20000126
                POP     {R4,PC}
; ---------------------------------------------------------------------------

loc_20000128
                ADDS    R3, R3, #2
                ADDS    R2, R2, #2
                SUBS    R1, R1, #2

loc_2000012E
                CMP     R1, #0
                BNE     loc_200000E8
                MOVS    R0, #0
                B       locret_20000126
; End of function ProgramPage_200000DC

; ---------------------------------------------------------------------------
                ALIGN 4
off_20000138    DCD 0x40022000
dword_2000013C  DCD 0x45670123
dword_20000140  DCD 0xCDEF89AB
off_20000144    DCD 0x40003000
                DCD 0
; seg000        ends

                END
